Index: trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp
===================================================================
--- trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 585)
+++ trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 712)
@@ -43,5 +43,5 @@
 #define DEBUG_CONFIG_CMD		1
 #define DEBUG_CONFIG_RSP		1
-#define DEBUG_MISS_WTI  		1
+#define DEBUG_MISS_WTI_CMD  		1
 
 namespace soclib { 
@@ -53,14 +53,20 @@
     {
         "DMA_CMD_IDLE",
-        "DMA_CMD_FIFO_PUT_CMD",
-        "DMA_CMD_FIFO_PUT_RSP",
-        "DMA_CMD_MISS_WAIT",
-        "DMA_CMD_WAIT_EOP",
+        "DMA_CMD_DMA_REQ",
+        "DMA_CMD_WTI_IOX_REQ",
+        "DMA_CMD_ERR_WAIT_EOP",
+        "DMA_CMD_ERR_WTI_REQ",
+        "DMA_CMD_ERR_RSP_REQ",
+        "DMA_CMD_TLB_MISS_WAIT",
     };
 
 const char *dma_rsp_fsm_state_str[] = 
     {
-        "DMA_RSP_IDLE",
-        "DMA_RSP_FIFO_PUT",
+        "DMA_RSP_IDLE_DMA",
+        "DMA_RSP_IDLE_WTI",
+        "DMA_RSP_IDLE_ERR",
+        "DMA_RSP_PUT_DMA",
+        "DMA_RSP_PUT_WTI",
+        "DMA_RSP_PUT_ERR",
     };
 
@@ -90,20 +96,17 @@
 const char *config_rsp_fsm_state_str[] = 
     {
-        "CONFIG_RSP_IDLE",
-        "CONFIG_RSP_PUT_LO", 
+        "CONFIG_RSP_IDLE_IOX",
+        "CONFIG_RSP_IDLE_LOC",
+        "CONFIG_RSP_PUT_LOW", 
         "CONFIG_RSP_PUT_HI", 
         "CONFIG_RSP_PUT_UNC", 
+        "CONFIG_RSP_PUT_LOC", 
     };
 
-const char *miss_wti_cmd_state_str[] = 
-    {  
-        "MISS_WTI_CMD_IDLE",
-        "MISS_WTI_CMD_WTI",
-        "MISS_WTI_CMD_MISS",
-    };
 const char *miss_wti_rsp_state_str[] = 
     {  
         "MISS_WTI_RSP_IDLE",
-        "MISS_WTI_RSP_WTI",
+        "MISS_WTI_RSP_WTI_IOX",
+        "MISS_WTI_RSP_WTI_MMU",
         "MISS_WTI_RSP_MISS",
     };
@@ -121,5 +124,4 @@
     const soclib::common::IntTab 	    &int_srcid,     // INT network SRCID
     const soclib::common::IntTab 	    &iox_tgtid,     // IOX network TGTID
-    const bool                          has_irqs,
     const size_t                        dcache_words,
     const size_t 				        iotlb_ways,
@@ -138,5 +140,4 @@
 
       m_words( dcache_words ),
-      m_has_irqs( has_irqs ),
 
       // INT & IOX Network
@@ -157,12 +158,26 @@
       r_iommu_etr("r_iommu_etr"),
       r_iommu_bad_id("r_iommu_bad_id"),
-      r_iommu_wti_paddr("r_iommu_wti_paddr"),
-      r_iommu_peri_wti(alloc_elems<sc_signal<vci_addr_t> >("r_peri_wti_paddr", 32)),
+      r_iommu_wti_enable("r_iommu_wti_enable"),
+      r_iommu_wti_addr_lo("r_iommu_wti_addr_lo"),
 
       // DMA_CMD FSM registers
       r_dma_cmd_fsm("r_dma_cmd_fsm"),
-      r_dma_cmd_vaddr("r_dma_cmd_vaddr"),
       r_dma_cmd_paddr("r_dma_cmd_paddr"),
 
+      r_dma_cmd_to_miss_wti_cmd_req("r_dma_cmd_to_miss_wti_cmd_req"),
+      r_dma_cmd_to_miss_wti_cmd_addr("r_dma_cmd_to_miss_wti_cmd_addr"),
+      r_dma_cmd_to_miss_wti_cmd_srcid("r_dma_cmd_to_miss_wti_cmd_srcid"),
+      r_dma_cmd_to_miss_wti_cmd_trdid("r_dma_cmd_to_miss_wti_cmd_trdid"),
+      r_dma_cmd_to_miss_wti_cmd_pktid("r_dma_cmd_to_miss_wti_cmd_pktid"),
+      r_dma_cmd_to_miss_wti_cmd_wdata("r_dma_cmd_to_miss_wti_cmd_wdata"),
+
+      r_dma_cmd_to_dma_rsp_req("r_dma_cmd_to_dma_rsp_req"),
+      r_dma_cmd_to_dma_rsp_rsrcid("r_dma_cmd_to_dma_rsp_rsrcid"),
+      r_dma_cmd_to_dma_rsp_rtrdid("r_dma_cmd_to_dma_rsp_rtrdid"),
+      r_dma_cmd_to_dma_rsp_rpktid("r_dma_cmd_to_dma_rsp_rpktid"),
+     
+      r_dma_cmd_to_tlb_req("r_dma_cmd_to_tlb_req"),
+      r_dma_cmd_to_tlb_vaddr("r_dma_cmd_to_tlb_vaddr"),
+      
       //DMA_RSP FSM registers
       r_dma_rsp_fsm("r_dma_rsp_fsm"),
@@ -170,7 +185,12 @@
       // CONFIG_CMD FSM registers 
       r_config_cmd_fsm("r_config_cmd_fsm"),
-      r_config_cmd_rdata("r_config_cmd_rdata"),
-      r_config_cmd_error("r_config_cmd_error"),
-      r_config_cmd_inval_vaddr("r_config_cmd_inval_vaddr"),
+
+      r_config_cmd_to_tlb_req("r_config_cmd_to_tlb_req"),
+      r_config_cmd_to_tlb_vaddr("r_config_cmd_to_tlb_vaddr"),
+
+      r_config_cmd_to_config_rsp_req("r_config_cmd_to_config_rsp_req"),
+      r_config_cmd_to_config_rsp_rerror("r_config_cmd_to_config_rsp_rerror"),
+      r_config_cmd_to_config_rsp_rdata("r_config_cmd_to_config_rsp_rdata"),
+
       r_config_cmd_wdata("r_config_cmd_wdata"),
       r_config_cmd_be("r_config_cmd_be"),
@@ -196,9 +216,11 @@
       r_tlb_miss_type("r_tlb_miss_type"),
       r_tlb_miss_error("r_tlb_miss_error"),
+
       r_tlb_paddr("r_tlb_paddr"),		 
       r_tlb_pte_flags("r_tlb_pte_flags"),
       r_tlb_pte_ppn("r_tlb_pte_ppn"),
       r_tlb_way("r_tlb_way"),
-      r_tlb_set("r_tlb_set"),    
+      r_tlb_set("r_tlb_set"), 
+   
       r_tlb_buf_valid("r_tlb_buf_valid"),
       r_tlb_buf_tag("r_tlb_buf_tag"),
@@ -206,28 +228,21 @@
       r_tlb_buf_big_page("r_tlb_buf_big_page"),
 
-      // MISS_WTI_CMD FSM registers
-      r_miss_wti_cmd_fsm("r_miss_wti_cmd_fsm"), 
-      r_miss_wti_cmd_index("r_miss_wti_cmd_index"),
-
-      // MISS_WTI_CMD FSM registers
+      r_tlb_to_miss_wti_cmd_req("r_tlb_to_miss_wti_cmd_req"),
+
+      // MISS_WTI_RSP FSM registers
       r_miss_wti_rsp_fsm("r_miss_wti_rsp_fsm"), 
-      r_miss_wti_rsp_error("r_miss_wti_rsp_error"),
-
-      // allocator for CONFIG_RSP & DMA_RSP fifos
-      r_alloc_fifo_config_rsp_local("r_alloc_fifo_config_rsp_local"), 
-      r_alloc_fifo_dma_rsp_local("r_alloc_fifo_dma_rsp_local"), 
-
-      // IRQs registers
-      r_irq_pending(alloc_elems<sc_signal<bool> >("r_irq_pending", 32)),
-      r_irq_request(alloc_elems<sc_signal<bool> >("r_irq_request", 32)),
-      
+      r_miss_wti_rsp_error_wti("r_miss_wti_rsp_error_wti"),
+      r_miss_wti_rsp_error_miss("r_miss_wti_rsp_error_miss"),
+      r_miss_wti_rsp_count("r_miss_wti_rsp_count"),
+
+      r_miss_wti_rsp_to_dma_rsp_req("r_miss_wti_rsp_to_dma_rsp_req"),
+      r_miss_wti_rsp_to_dma_rsp_rerror("r_miss_wti_rsp_to_dma_rsp_rerror"),
+      r_miss_wti_rsp_to_dma_rsp_rsrcid("r_miss_wti_rsp_to_dma_rsp_rsrcid"),
+      r_miss_wti_rsp_to_dma_rsp_rtrdid("r_miss_wti_rsp_to_dma_rsp_rtrdid"),
+      r_miss_wti_rsp_to_dma_rsp_rpktid("r_miss_wti_rsp_to_dma_rsp_rpktid"),
+
       // TLB for IOMMU
       r_iotlb("iotlb", 0, iotlb_ways, iotlb_sets, vci_param_int::N),
      
-      // Inter-FSM communications
-      r_dma_tlb_req("r_dma_tlb_req"),
-      r_config_tlb_req("r_config_tlb_req"),
-      r_tlb_miss_req("r_tlb_miss_req"),
-      
       // DMA_CMD FIFOs
       m_dma_cmd_addr_fifo("m_dma_cmd_addr_fifo",2),
@@ -276,5 +291,21 @@
       m_config_rsp_rpktid_fifo("m_config_rsp_rpktid_fifo",2),
       m_config_rsp_reop_fifo("m_config_rsp_reop_fifo",2),
-      m_config_rsp_rerror_fifo("m_config_rsp_rerror_fifo",2)
+      m_config_rsp_rerror_fifo("m_config_rsp_rerror_fifo",2),
+
+      // MISS_WTI_CMD FIFOs
+      m_miss_wti_cmd_addr_fifo("m_miss_wti_cmd_addr_fifo",2),
+      m_miss_wti_cmd_srcid_fifo("m_miss_wti_cmd_srcid_fifo",2),
+      m_miss_wti_cmd_trdid_fifo("m_miss_wti_cmd_trdid_fifo",2),
+      m_miss_wti_cmd_pktid_fifo("m_miss_wti_cmd_pktid_fifo",2),
+      m_miss_wti_cmd_be_fifo("m_miss_wti_cmd_be_fifo",2),
+      m_miss_wti_cmd_cmd_fifo("m_miss_wti_cmd_cmd_fifo",2),
+      m_miss_wti_cmd_contig_fifo("m_miss_wti_cmd_contig_fifo",2),
+      m_miss_wti_cmd_data_fifo("m_miss_wti_cmd_data_fifo",2),
+      m_miss_wti_cmd_eop_fifo("m_miss_wti_cmd_eop_fifo",2),
+      m_miss_wti_cmd_cons_fifo("m_miss_wti_cmd_cons_fifo",2),
+      m_miss_wti_cmd_plen_fifo("m_miss_wti_cmd_plen_fifo",2),
+      m_miss_wti_cmd_wrap_fifo("m_miss_wti_cmd_wrap_fifo",2),
+      m_miss_wti_cmd_cfixed_fifo("m_miss_wti_cmd_cfixed_fifo",2),
+      m_miss_wti_cmd_clen_fifo("m_miss_wti_cmd_clen_fifo",2)
 {
     std::cout << "  - Building VciIoBridge : " << name << std::endl;
@@ -320,10 +351,4 @@
             "VCI_IO_BRIDGE ERROR: SRCID widths must be equal on the 3 networks");
 
-    // contruct 32 IRQ ports if required
-    if ( has_irqs )
-    {
-        for ( size_t n=0 ; n<32 ; n++ ) p_irq[n] = new sc_core::sc_in<bool>;
-    }
-    
     // Cache line buffer
     r_tlb_buf_data = new uint32_t[dcache_words];
@@ -343,9 +368,5 @@
 /////////////////////////////////////
 {
-    delete [] r_iommu_peri_wti;
     delete [] r_tlb_buf_data;
-    soclib::common::dealloc_elems(p_irq, 32);
-    soclib::common::dealloc_elems(r_irq_request, 32);
-    soclib::common::dealloc_elems(r_irq_pending, 32);
 }
 
@@ -363,5 +384,4 @@
               << " | " << config_cmd_fsm_state_str[r_config_cmd_fsm.read()]
               << " | " << config_rsp_fsm_state_str[r_config_rsp_fsm.read()]
-              << " | " << miss_wti_cmd_state_str[r_miss_wti_cmd_fsm.read()]
               << " | " << miss_wti_rsp_state_str[r_miss_wti_rsp_fsm.read()]
               << std::endl;
@@ -396,4 +416,14 @@
 }
 
+////////////////////////////////////
+tmpl(bool)::is_wti(vci_addr_t paddr)
+////////////////////////////////////
+{
+    uint32_t addr32 = (uint32_t)paddr;
+    uint32_t base   = r_xicu_base.read();
+    uint32_t size   = r_xicu_size.read();
+    return ( (addr32 >= base) and (addr32 < (base + size)) ); 
+}
+
 /////////////////////////
 tmpl(void)::transition()
@@ -403,18 +433,17 @@
     {
         r_dma_cmd_fsm	   = DMA_CMD_IDLE;
-        r_dma_rsp_fsm	   = DMA_RSP_IDLE;
+        r_dma_rsp_fsm	   = DMA_RSP_IDLE_DMA;
         r_tlb_fsm	       = TLB_IDLE;
         r_config_cmd_fsm   = CONFIG_CMD_IDLE;
-        r_config_rsp_fsm   = CONFIG_RSP_IDLE;
-        r_miss_wti_cmd_fsm = MISS_WTI_CMD_IDLE;
+        r_config_rsp_fsm   = CONFIG_RSP_IDLE_IOX;
         r_miss_wti_rsp_fsm = MISS_WTI_RSP_IDLE;
-
-        r_alloc_fifo_config_rsp_local = true;
-        r_alloc_fifo_dma_rsp_local    = true;
 
         r_tlb_buf_valid    = false; 
 		r_iommu_active     = false;
 		r_iommu_wti_enable = false;
-        
+
+        r_xicu_size        = 0;
+        r_xicu_base        = 0;
+
         // initializing FIFOs
         m_dma_cmd_addr_fifo.init();
@@ -455,4 +484,19 @@
         m_config_cmd_clen_fifo.init();
         
+        m_miss_wti_cmd_addr_fifo.init();
+        m_miss_wti_cmd_srcid_fifo.init();
+        m_miss_wti_cmd_trdid_fifo.init();
+        m_miss_wti_cmd_pktid_fifo.init();
+        m_miss_wti_cmd_be_fifo.init();
+        m_miss_wti_cmd_cmd_fifo.init();
+        m_miss_wti_cmd_contig_fifo.init();
+        m_miss_wti_cmd_data_fifo.init();
+        m_miss_wti_cmd_eop_fifo.init();
+        m_miss_wti_cmd_cons_fifo.init();
+        m_miss_wti_cmd_plen_fifo.init();
+        m_miss_wti_cmd_wrap_fifo.init();
+        m_miss_wti_cmd_cfixed_fifo.init();
+        m_miss_wti_cmd_clen_fifo.init();
+        
         m_config_rsp_rsrcid_fifo.init();
         m_config_rsp_rtrdid_fifo.init();
@@ -463,28 +507,30 @@
         
         // SET/RESET Communication flip-flops 
-        r_dma_tlb_req		        = false;
-        r_config_tlb_req		    = false;
-        r_tlb_miss_req              = false;
+        r_dma_cmd_to_miss_wti_cmd_req  = false;
+        r_dma_cmd_to_dma_rsp_req       = false;
+        r_dma_cmd_to_tlb_req		   = false;
+        r_config_cmd_to_tlb_req		   = false;
+        r_config_cmd_to_config_rsp_req = false;
+        r_tlb_to_miss_wti_cmd_req      = false;
+        r_miss_wti_rsp_to_dma_rsp_req  = false;
+
+        // error flip_flops
+        r_miss_wti_rsp_error_miss      = false;
+        r_miss_wti_rsp_error_wti       = false;
 
         // Debug variable
-		m_debug_activated	        = false;
+		m_debug_activated	           = false;
         
-        for ( size_t n=0 ; n<32 ; n++ )
-        {
-            r_irq_pending[n]        = false;
-            r_irq_request[n]        = false;
-        }
-          
 	    // activity counters
-	    m_cpt_total_cycles            = 0;
-        m_cpt_iotlb_read              = 0;             
-        m_cpt_iotlb_miss              = 0;             
-        m_cpt_iotlbmiss_transaction   = 0;    
-        m_cost_iotlbmiss_transaction  = 0;   
+	    m_cpt_total_cycles             = 0;
+        m_cpt_iotlb_read               = 0;             
+        m_cpt_iotlb_miss               = 0;             
+        m_cpt_iotlbmiss_transaction    = 0;    
+        m_cost_iotlbmiss_transaction   = 0;   
         
-        m_cpt_trt_dma_full            = 0;
-        m_cpt_trt_dma_full_cost       = 0;
-        m_cpt_trt_config_full         = 0;
-        m_cpt_trt_config_full_cost    = 0;
+        m_cpt_trt_dma_full             = 0;
+        m_cpt_trt_dma_full_cost        = 0;
+        m_cpt_trt_config_full          = 0;
+        m_cpt_trt_config_full_cost     = 0;
 
         for (uint32_t i=0; i<32 ; ++i) m_cpt_fsm_dma_cmd            [i]   = 0;
@@ -493,5 +539,4 @@
         for (uint32_t i=0; i<32 ; ++i) m_cpt_fsm_config_cmd         [i]   = 0;
         for (uint32_t i=0; i<32 ; ++i) m_cpt_fsm_config_rsp         [i]   = 0;
-        for (uint32_t i=0; i<32 ; ++i) m_cpt_fsm_miss_wti_cmd       [i]   = 0;
         for (uint32_t i=0; i<32 ; ++i) m_cpt_fsm_miss_wti_rsp       [i]   = 0;
 
@@ -499,16 +544,37 @@
     }
 
-    // default values for FIFOs
-    bool        dma_cmd_fifo_put      = false;
-    bool        dma_cmd_fifo_get      = false;
-
-    bool        dma_rsp_fifo_put      = false; 
-    bool        dma_rsp_fifo_get      = false; 
+    // default values for the 5 FIFOs
+    bool            dma_cmd_fifo_put          = false;
+    bool            dma_cmd_fifo_get          = p_vci_ini_ram.cmdack.read();
     
-    bool        config_cmd_fifo_put   = false;
-    bool        config_cmd_fifo_get   = false;
-
-    bool        config_rsp_fifo_put   = false;
-    bool        config_rsp_fifo_get   = false;
+    bool            dma_rsp_fifo_put          = false; 
+    bool            dma_rsp_fifo_get          = p_vci_tgt_iox.rspack.read();
+    vci_rerror_t    dma_rsp_fifo_rerror       = 0;
+    vci_srcid_t     dma_rsp_fifo_rsrcid       = 0;
+    vci_trdid_t     dma_rsp_fifo_rtrdid       = 0;
+    vci_pktid_t     dma_rsp_fifo_rpktid       = 0;
+    ext_data_t      dma_rsp_fifo_rdata        = 0;
+    bool            dma_rsp_fifo_reop         = false;
+
+    bool            config_cmd_fifo_put       = false;
+    bool            config_cmd_fifo_get       = p_vci_ini_iox.cmdack.read();
+
+    bool            config_rsp_fifo_put       = false;
+    bool            config_rsp_fifo_get       = p_vci_tgt_int.rspack.read();
+    vci_rerror_t    config_rsp_fifo_rerror    = 0;
+    vci_srcid_t     config_rsp_fifo_rsrcid    = 0;
+    vci_trdid_t     config_rsp_fifo_rtrdid    = 0;
+    vci_pktid_t     config_rsp_fifo_rpktid    = 0;
+    ext_data_t      config_rsp_fifo_rdata     = 0;
+    bool            config_rsp_fifo_reop      = false;
+
+    bool            miss_wti_cmd_fifo_put     = false;
+    bool            miss_wti_cmd_fifo_get     = p_vci_ini_int.cmdack.read();
+    vci_addr_t      miss_wti_cmd_fifo_address = 0;
+    vci_cmd_t       miss_wti_cmd_fifo_cmd     = 0;
+    vci_srcid_t     miss_wti_cmd_fifo_srcid   = 0;
+    vci_trdid_t     miss_wti_cmd_fifo_trdid   = 0;
+    vci_pktid_t     miss_wti_cmd_fifo_pktid   = 0;
+    int_data_t      miss_wti_cmd_fifo_wdata   = 0;
 
 #ifdef INSTRUMENTATION
@@ -518,5 +584,4 @@
     m_cpt_fsm_config_cmd	    [r_config_cmd_fsm.read() ] ++;
     m_cpt_fsm_config_rsp	    [r_config_rsp_fsm.read() ] ++;
-    m_cpt_fsm_miss_wti_cmd      [r_miss_wti_cmd_fsm.read() ] ++;
     m_cpt_fsm_miss_wti_rsp      [r_miss_wti_rsp_fsm.read() ] ++;
 #endif
@@ -527,6 +592,17 @@
 
     //////////////////////////////////////////////////////////////////////////////
-    // The DMA_CMD_FSM handles DMA transactions requested by peripherals
-    // It makes the address translation if IOMMU is activated.
+    // The DMA_CMD_FSM handles transactions requested by peripherals.
+    // - it can be DMA transactions to RAM network (DMA_REQ state).
+    // - it can be WTI transactions to INT network (EXT_WTI_REQ state).
+    // It makes the address translation if IOMMU is activated, requesting
+    // the TLB_MISS FSM in case of TLB miss (TLB_MISS_WAIT state).
+    // When the IOMMU is activated, a DMA request can fail in two cases:
+    // - write to a read-only address : detected in IDLE state
+    // - virtual address unmapped     : detected in MISS_WAIT state
+    // In both cases of violation, the DMA_CMD FSM makes the following actions :
+    // 1. register the error in r_iommu_*** registers
+    // 2. wait the faulty command EOP (ERR_WAIT_EOP state)
+    // 3. request a IOMMU WTI to MISS_WTI FSM, (ERR_WTI_REQ state)
+    // 4. request a response error to DMA_RSP FSM (ERR_RSP_REQ state)
     ///////////////////////////////////////////////////////////////////////////////
 
@@ -534,25 +610,38 @@
     {
     //////////////////
-    case DMA_CMD_IDLE:  // waiting DMA VCI transaction
-    {
-        if ( p_vci_tgt_iox.cmdval.read() ) // compute physical address 
+    case DMA_CMD_IDLE:  // wait a DMA or WTI VCI transaction and route it
+                        // after an IOMMU translation if IOMMU activated.
+                        // no VCI flit is consumed in this state
+    {
+        if ( p_vci_tgt_iox.cmdval.read() ) 
         { 
             if ( not r_iommu_active.read() ) 	// tlb not activated 
             {
+                // save paddr address
+                r_dma_cmd_paddr = p_vci_tgt_iox.address.read();
+
+                // analyse paddr for WTI/DMA routing
+                // WTI requests must be single flit (READ or WRITE)
+                if ( is_wti( p_vci_tgt_iox.address.read() ) )
+                {
+                    assert( p_vci_tgt_iox.eop.read() and 
+                    "ERROR in VCI_IOB illegal VCI WTI command from IOX network");
+
+                    r_dma_cmd_fsm = DMA_CMD_WTI_IOX_REQ;
+                }
+                else
+                {
+                    r_dma_cmd_fsm = DMA_CMD_DMA_REQ;
+                }
+
 #if DEBUG_DMA_CMD
 if( m_debug_activated )
-std::cout << "  <IOB DMA_CMD_IDLE> @@@ dma command" << std::endl
-          << "  address = " << std::hex << p_vci_tgt_iox.address.read()
+std::cout << "  <IOB DMA_CMD_IDLE> DMA command" << std::endl
+          << " : address = " << std::hex << p_vci_tgt_iox.address.read()
           << " / srcid = " << p_vci_tgt_iox.srcid.read()
-          << " / trdid = " << p_vci_tgt_iox.trdid.read()
           << " / wdata = " << std::hex << p_vci_tgt_iox.wdata.read()
-          << " / be = " << p_vci_tgt_iox.be.read()
           << " / plen = " << std::dec << p_vci_tgt_iox.plen.read()
           << " / eop = " << p_vci_tgt_iox.eop.read() << std::endl;
-
-#endif
-                // put DMA transaction into DMA_CMD fifo
-                r_dma_cmd_paddr = p_vci_tgt_iox.address.read();
-                r_dma_cmd_fsm   = DMA_CMD_FIFO_PUT_CMD;
+#endif
             }
             else if (r_tlb_fsm.read() == TLB_IDLE ||
@@ -581,9 +670,16 @@
                         (p_vci_tgt_iox.cmd.read() == vci_param_ext::CMD_WRITE) ) 
                     {
-                        // put DMA response error into DMA_RSP fifo
+                        // register error
                         r_iommu_etr      = MMU_WRITE_ACCES_VIOLATION;  
                         r_iommu_bvar     = p_vci_tgt_iox.address.read();
                         r_iommu_bad_id   = p_vci_tgt_iox.srcid.read();
-                        r_dma_cmd_fsm    = DMA_CMD_FIFO_PUT_RSP;
+                        
+                        // prepare response error request to DMA_RSP FSM
+                        r_dma_cmd_to_dma_rsp_rsrcid = p_vci_tgt_iox.srcid.read();
+                        r_dma_cmd_to_dma_rsp_rtrdid = p_vci_tgt_iox.trdid.read();
+                        r_dma_cmd_to_dma_rsp_rpktid = p_vci_tgt_iox.pktid.read();
+
+                        // jumps IOMMU error sequence
+                        r_dma_cmd_fsm = DMA_CMD_ERR_WAIT_EOP;
 #if DEBUG_DMA_CMD
 if( m_debug_activated )
@@ -597,7 +693,20 @@
 std::cout << "  <IOB DMA_CMD_IDLE> TLB HIT" << std::endl;
 #endif
-                    // put DMA transaction into DMA_CMD fifo
-                    r_dma_cmd_paddr   = iotlb_paddr;			
-                    r_dma_cmd_fsm     = DMA_CMD_FIFO_PUT_CMD;
+                        // save paddr address
+                        r_dma_cmd_paddr = iotlb_paddr;
+
+                        // analyse address for WTI/DMA routing
+                        if ( is_wti( iotlb_paddr ) )
+                        {
+                            assert( p_vci_tgt_iox.eop.read() and 
+                                   (p_vci_tgt_iox.cmd == vci_param_int::CMD_WRITE) and
+                            "ERROR in VCI_IOB illegal VCI WTI command from IOX network");
+
+                            r_dma_cmd_fsm   = DMA_CMD_WTI_IOX_REQ; 
+                        }
+                        else
+                        {
+                            r_dma_cmd_fsm = DMA_CMD_DMA_REQ;
+                        }
                     }
                 }
@@ -608,20 +717,22 @@
 m_cpt_iotlb_miss++;
 #endif
-                        // register virtual address, and send request to TLB FSM 
-		                r_dma_cmd_vaddr = p_vci_tgt_iox.address.read();
-                        r_dma_tlb_req   = true;
-                        r_dma_cmd_fsm   = DMA_CMD_MISS_WAIT;
+                    // register virtual address, and send request to TLB FSM 
+		            r_dma_cmd_to_tlb_vaddr = p_vci_tgt_iox.address.read();
+                    r_dma_cmd_to_tlb_req   = true;
+                    r_dma_cmd_fsm          = DMA_CMD_TLB_MISS_WAIT;
 #if DEBUG_DMA_CMD
 if( m_debug_activated )
 std::cout << "  <IOB DMA_CMD_IDLE> TLB MISS" << std::endl;
 #endif
-                } // end !hit 
+                } // end tlb miss 
             } // end if tlb_activated
         } // end if cmdval
         break;
     }
-    //////////////////////////
-    case DMA_CMD_FIFO_PUT_CMD:    // put a DMA transaction in DMA_CMD fifo	 
-                                  // if contig, VCI address must be incremented
+    /////////////////////
+    case DMA_CMD_DMA_REQ:    // put a flit in DMA_CMD FIFO
+                             // if contig, VCI address must be incremented 
+                             // after initial translation by IOMMU.
+                             // flit is consumed if DMA_CMD FIFO not full
     {
         if ( p_vci_tgt_iox.cmdval && m_dma_cmd_addr_fifo.wok() ) 
@@ -639,55 +750,103 @@
           << " address = " << std::hex << r_dma_cmd_paddr.read()
           << " srcid = " << p_vci_tgt_iox.srcid.read()
-          << " trdid = " << p_vci_tgt_iox.trdid.read()
           << " wdata = " << p_vci_tgt_iox.wdata.read()
-          << " be = " << p_vci_tgt_iox.be.read()
-          << " contig = " << p_vci_tgt_iox.contig.read()
-          << " eop = " << std::dec << p_vci_tgt_iox.eop.read() 
-          << " plen = " << std::dec << p_vci_tgt_iox.plen.read() << std::endl;
+          << " plen = " << std::dec << p_vci_tgt_iox.plen.read()
+          << " eop = " << std::dec << p_vci_tgt_iox.eop.read() << std::endl;
 #endif
         }
         break;
     }
-    //////////////////////
-    case DMA_CMD_WAIT_EOP:	 // An error has been detected on the VCI DMA command
-                             // consume the VCI packet before sending the error response
-    {
-        if ( p_vci_tgt_iox.eop.read() )    r_dma_cmd_fsm   = DMA_CMD_FIFO_PUT_RSP;
-        break;
-    }
-    //////////////////////////
-    case DMA_CMD_FIFO_PUT_RSP:	 // try to put a response error in DMA_RSP fifo
-                                 // The FIFO is shared with DMA_RSP FSM 
-                                 // and we must we wait for allocation...
-    {
-        if ( r_alloc_fifo_dma_rsp_local.read() ) 
+    /////////////////////////
+    case DMA_CMD_WTI_IOX_REQ:    // post a WTI_IOX request to MISS_WTI FSM 
+                                 // if no prending previous request
+                                 // command arguments are stored in dedicated registers 
+                                 // VCI flit is consumed if no previous request
+    {
+        if ( not r_dma_cmd_to_miss_wti_cmd_req.read() )  // no previous pending request
         {
-            dma_rsp_fifo_put = true;
-
-            if( m_dma_rsp_data_fifo.wok() )
-            {
-
+            r_dma_cmd_to_miss_wti_cmd_req   = true;
+            r_dma_cmd_to_miss_wti_cmd_addr  = p_vci_tgt_iox.address.read();
+            r_dma_cmd_to_miss_wti_cmd_cmd   = p_vci_tgt_iox.cmd.read();
+            r_dma_cmd_to_miss_wti_cmd_wdata = (uint32_t)p_vci_tgt_iox.wdata.read();
+            r_dma_cmd_to_miss_wti_cmd_srcid = p_vci_tgt_iox.srcid.read();
+            r_dma_cmd_to_miss_wti_cmd_trdid = p_vci_tgt_iox.trdid.read();
+            r_dma_cmd_to_miss_wti_cmd_pktid = PKTID_WTI_IOX;
+
+            r_dma_cmd_fsm = DMA_CMD_IDLE;
+           
 #if DEBUG_DMA_CMD
 if( m_debug_activated ) 
-std::cout << "  <IOB DMA_CMD_FIFO_PUT_RSP> Put a response error to a DMA transaction." 
-          << std::endl;
-#endif
-                r_dma_cmd_fsm = DMA_CMD_IDLE;
-            }
+std::cout << "  <IOB DMA_CMD_WTI_IOX_REQ> request WTI transaction from ext peripheral"
+          << " : address = " << std::hex << r_dma_cmd_paddr.read()
+          << " / srcid = " << p_vci_tgt_iox.srcid.read()
+          << " / wdata = " << p_vci_tgt_iox.wdata.read() << std::endl;
+#endif
         }
         break;
     }
-    ///////////////////////
-    case DMA_CMD_MISS_WAIT:  // waiting completion of a TLB miss
-                             // we must test a possible page fault error...   
-    {
-        if ( not r_dma_tlb_req.read() ) // TLB miss completed
+    //////////////////////////
+    case DMA_CMD_ERR_WAIT_EOP:	 // wait EOP before requesting WTI & error response
+                                 // VCI flit is always consumed
+    {
+        if ( p_vci_tgt_iox.eop.read() ) r_dma_cmd_fsm = DMA_CMD_ERR_WTI_REQ;
+
+#if DEBUG_DMA_CMD
+if( m_debug_activated ) 
+std::cout << "  <IOB DMA_CMD_WAIT_EOP> wait EOP for faulty DMA command" << std::endl;
+#endif
+        break;
+    }
+    
+    /////////////////////////
+    case DMA_CMD_ERR_WTI_REQ:	 // post a WTI_MMU request to MISS_WTI_CMD FSM
+                                 // if no prending previous request
+                                 // response arguments are stored in dedicated registers
+                                 // no VCI flit is consumed 
+    {
+        if ( not r_dma_cmd_to_miss_wti_cmd_req.read() )  // no pending previous request
+        {
+            r_dma_cmd_to_miss_wti_cmd_req   = true;
+            r_dma_cmd_to_miss_wti_cmd_addr  = (vci_addr_t)r_iommu_wti_addr_lo.read() |
+                                              (((vci_addr_t)r_iommu_wti_addr_hi.read())<<32);
+            r_dma_cmd_to_miss_wti_cmd_wdata = 0;
+            r_dma_cmd_to_miss_wti_cmd_srcid = m_int_srcid;
+            r_dma_cmd_to_miss_wti_cmd_trdid = 0;
+            r_dma_cmd_to_miss_wti_cmd_pktid = PKTID_WTI_MMU;
+
+            r_dma_cmd_fsm            = DMA_CMD_ERR_RSP_REQ;
+
+#if DEBUG_DMA_CMD
+if( m_debug_activated ) 
+std::cout << "  <IOB DMA_CMD_ERR_WTI_REQ> request an IOMMU WTI" << std::endl;
+#endif
+        }
+        break;
+    }
+    /////////////////////////
+    case DMA_CMD_ERR_RSP_REQ:    // post an error response request to DMA_RSP FSM
+                                 // if no prending previous request
+                                 // response arguments are stored in dedicated registers
+                                 // no VCI flit is consumed 
+    {
+        if ( not r_dma_cmd_to_dma_rsp_req.read() )  // no pending previous request
+        {
+            r_dma_cmd_to_dma_rsp_req    = true;
+            r_dma_cmd_to_dma_rsp_rerror = 0x1;
+            r_dma_cmd_to_dma_rsp_rdata  = 0;
+        }
+        break;
+    }
+    ///////////////////////////
+    case DMA_CMD_TLB_MISS_WAIT:  // waiting completion of a TLB miss
+                                 // we must test a possible page fault error...   
+    {
+        if ( not r_dma_cmd_to_tlb_req.read() ) // TLB miss completed
         {
             if ( r_tlb_miss_error.read() )   // Error reported by TLB FSM
             {
                 r_iommu_etr     = MMU_READ_PT2_UNMAPPED; 
-                r_iommu_bvar    = r_dma_cmd_vaddr.read();
+                r_iommu_bvar    = r_dma_cmd_to_tlb_vaddr.read();
                 r_iommu_bad_id  = p_vci_tgt_iox.srcid.read();
-                r_dma_cmd_fsm   = DMA_CMD_FIFO_PUT_RSP;
+                r_dma_cmd_fsm   = DMA_CMD_ERR_WAIT_EOP;
             }
             else                            // No error
